﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GroupingUnGroupingSpread
{
    public partial class Form1 : Form
    {
        FarPoint.Win.Spread.Model.GroupDataModel gm;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            GetData();
            fpSpread1.AllowColumnMove = true;
            fpSpread1.ActiveSheet.GroupBarInfo.Visible = true;
            fpSpread1.ActiveSheet.AllowGroup = true;
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 0].Text = "Number1";
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 1].Text = "Number2";
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 2].Text = "Number3";
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 3].Text = "Text1";
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 4].Text = "Text2";
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 5].Text = "Text3";
            fpSpread1.ActiveSheet.ColumnHeader.Cells[0, 6].Text = "Text4";           
        }

        private void button1_Click(object sender, EventArgs e)
        {
            FarPoint.Win.Spread.Model.GroupDataModel gm = new FarPoint.Win.Spread.Model.GroupDataModel(fpSpread1.Sheets[0].Models.Data);
            FarPoint.Win.Spread.SortInfo[] si = new FarPoint.Win.Spread.SortInfo[3];
            si[0] =new FarPoint.Win.Spread.SortInfo(0, true);
            si[1] = new FarPoint.Win.Spread.SortInfo(1, true);
            si[2] = new FarPoint.Win.Spread.SortInfo(2, true);
            gm.Group(si);
            fpSpread1.Sheets[0].Models.Data = gm;
        }

        private void GetData()
        {
            DataSet ds = new DataSet();
            DataTable dt = default(DataTable);
            dt = new DataTable();
            dt.Columns.Add(new DataColumn("Number1", typeof(string)));
            dt.Columns.Add(new DataColumn("Number2", typeof(string)));
            dt.Columns.Add(new DataColumn("Number3", typeof(string)));
            dt.Columns.Add(new DataColumn("Text1", typeof(string)));
            dt.Columns.Add(new DataColumn("Text2", typeof(string)));
            dt.Columns.Add(new DataColumn("Text3", typeof(string)));
            dt.Columns.Add(new DataColumn("Text4", typeof(decimal)));
            dt.Rows.Add(new object[] { "101", "1", "0", "Num1", "Num2", "Num3", 21000 });
            dt.Rows.Add(new object[] { "201", "2", "0", "a", "b", "c", 9400 });
            dt.Rows.Add(new object[] { "203", "2", "0", "Jan", "Feb", "March", 4550 });
            dt.Rows.Add(new object[] { "301", "3", "1", "First", "Second", "Third", 32000 });
            dt.Rows.Add(new object[] { "302", "3", "1", "Test", "Test1", "Test2", 13280 });
            dt.Rows.Add(new object[] { "204", "2", "0", "Mon", "Tues", "Wed", 1700 });
            dt.Rows.Add(new object[] { "303", "3", "1", "Week1", "Week2", "Week3", 36080 });
            dt.Rows.Add(new object[] { "402", "4", "1", "d", "e", "f", 31500 });
            dt.Rows.Add(new object[] { "405", "4", "1", "July", "August", "September", 4958 });
            dt.Rows.Add(new object[] { "102", "1", "0", "next", "aaa", "max", 1539 });
            ds.Tables.Add(dt);

            FarPoint.Win.Spread.Data.SpreadDataBindingAdapter Sdba = new FarPoint.Win.Spread.Data.SpreadDataBindingAdapter();
            Sdba.DataSource = ds.Tables[0];
            Sdba.Spread = fpSpread1;
            Sdba.SheetName = fpSpread1.ActiveSheet.SheetName;
            Sdba.AutoGenerateRow = true;
            Sdba.DataAutoCellTypes = false;
            Sdba.MapperInfo = new FarPoint.Win.Spread.Data.MapperInfo(0, 0, 10, 7);
            Sdba.FillSpreadDataByDataSource();

        }
        private void button2_Click(object sender, EventArgs e)
        {
            fpSpread1.Sheets[0].Models.Data = ((FarPoint.Win.Spread.Model.GroupDataModel)fpSpread1.Sheets[0].Models.Data).TargetModel;
        }
    }
}
